/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupMember type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupMember{}

// GroupMember struct for GroupMember
type GroupMember struct {
	MemberGroups     []GroupMemberItem `json:"memberGroups,omitempty"`
	MemberIdentities []GroupMemberItem `json:"memberIdentities,omitempty"`
}

// NewGroupMember instantiates a new GroupMember object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupMember() *GroupMember {
	this := GroupMember{}
	return &this
}

// NewGroupMemberWithDefaults instantiates a new GroupMember object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupMemberWithDefaults() *GroupMember {
	this := GroupMember{}
	return &this
}

// GetMemberGroups returns the MemberGroups field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMember) GetMemberGroups() []GroupMemberItem {
	if o == nil {
		var ret []GroupMemberItem
		return ret
	}
	return o.MemberGroups
}

// GetMemberGroupsOk returns a tuple with the MemberGroups field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMember) GetMemberGroupsOk() ([]GroupMemberItem, bool) {
	if o == nil || IsNil(o.MemberGroups) {
		return nil, false
	}
	return o.MemberGroups, true
}

// HasMemberGroups returns a boolean if a field has been set.
func (o *GroupMember) HasMemberGroups() bool {
	if o != nil && !IsNil(o.MemberGroups) {
		return true
	}

	return false
}

// SetMemberGroups gets a reference to the given []GroupMemberItem and assigns it to the MemberGroups field.
func (o *GroupMember) SetMemberGroups(v []GroupMemberItem) {
	o.MemberGroups = v
}

// GetMemberIdentities returns the MemberIdentities field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *GroupMember) GetMemberIdentities() []GroupMemberItem {
	if o == nil {
		var ret []GroupMemberItem
		return ret
	}
	return o.MemberIdentities
}

// GetMemberIdentitiesOk returns a tuple with the MemberIdentities field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *GroupMember) GetMemberIdentitiesOk() ([]GroupMemberItem, bool) {
	if o == nil || IsNil(o.MemberIdentities) {
		return nil, false
	}
	return o.MemberIdentities, true
}

// HasMemberIdentities returns a boolean if a field has been set.
func (o *GroupMember) HasMemberIdentities() bool {
	if o != nil && !IsNil(o.MemberIdentities) {
		return true
	}

	return false
}

// SetMemberIdentities gets a reference to the given []GroupMemberItem and assigns it to the MemberIdentities field.
func (o *GroupMember) SetMemberIdentities(v []GroupMemberItem) {
	o.MemberIdentities = v
}

func (o GroupMember) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupMember) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.MemberGroups != nil {
		toSerialize["memberGroups"] = o.MemberGroups
	}
	if o.MemberIdentities != nil {
		toSerialize["memberIdentities"] = o.MemberIdentities
	}
	return toSerialize, nil
}

type NullableGroupMember struct {
	value *GroupMember
	isSet bool
}

func (v NullableGroupMember) Get() *GroupMember {
	return v.value
}

func (v *NullableGroupMember) Set(val *GroupMember) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupMember) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupMember) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupMember(val *GroupMember) *NullableGroupMember {
	return &NullableGroupMember{value: val, isSet: true}
}

func (v NullableGroupMember) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupMember) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
